setDefaultTab("PVP")

UI.Separator()

addTextEdit("lider", storage.leader or "Leader Name", function(widget, text) storage.leader = text end)

local combo = macro(333, "Activate Combo", function() end)

--onTalk(function(name, level, mode, text, channelId, pos)
--    if combo.isOn() then
--        if name:lower() == storage.leader:lower() then
--            if string.find(text, "Attack#") then
--			  if string.find(text, ".") then
--                local count = 0
--                for attack in string.gmatch(text, "([^#]+)") do
--                    if count > 0 then
--                        g_game.attack(getCreatureByName(attack))
--                    end
--                    count = count + 1
--                end
--            end
--        end
--    end
--end)

onTalk(function(name, level, mode, text, channelId, pos)
    if combo.isOn() then
--        if name:lower() == storage.leader:lower() then
		if name:lower() == storage.leader:lower() or name:lower() == "roronoa zoro" or name:lower() == "zumbie" then
            local nome = text:gsub("%.", "")
            g_game.attack(getCreatureByName(nome))
        end
    end
end)


--macro(333, "Activate Leader Combo", function()
--    local creature = g_game.getAttackingCreature()
--    if creature and creature:isPlayer() then
--        if storage.attacking == creature then
--            return
--        end

--        storage.attacking = creature
--        say("Attack#"..creature:getName())
--    end
--end)

macro(333, "Activate Leader Combo", function()
    local creature = g_game.getAttackingCreature()
    if creature and creature:isPlayer() then
								       sayChannel(0, "."..creature:getName())
--									       sayChannel(1, "."..creature:getName())
--										       sayChannel(2, "."..creature:getName())
        delay(2000)
    end
end)

local creatureId = nil;
local stopAttackRequested = false

keepTarget = {
    setTarget = function(_creatureId)
        creatureId = _creatureId
    end,

    stopAttack = function()
        stopAttackRequested = true
    end
}

local creatureId = nil;
local stopAttackRequested = false

keepTarget = {
    setTarget = function(_creatureId)
        creatureId = _creatureId
    end,

    stopAttack = function()
        stopAttackRequested = true
    end
}

keepTarget.macro = macro(1, "Lock Target", function()
    if g_game.getFollowingCreature() then
        keepTarget.stopAttack()
    end

    local creature = g_game.getAttackingCreature()

    if creature and creatureId ~= creature:getId() then
        keepTarget.setTarget(creature:getId())
    end

    if creatureId and not creature and not stopAttackRequested then
        local target = getCreatureById(creatureId)
        if target then
            attack(target)
        end

    elseif stopAttackRequested then
        creatureId = nil
        g_game.cancelAttack()
        stopAttackRequested = false
    end
end)

onKeyUp(function(keys)
    if keys == "Escape" then
        keepTarget.stopAttack()
    end
end)

UI.Separator()

macro(333, "Paralyze Rune",  function(target)
    if g_game.isAttacking() then
        local enemy = g_game.getAttackingCreature()
        if (enemy:isPlayer()) then
            usewith(3165, enemy)
        end
    end
end)

local mwTiles = {}
local autoMw = false

onKeyPress(function(keys)
    if keys == "PageUp" and autoMw then
        local tile = getTileUnderCursor()
        local currTile = table.find(mwTiles, tile)
        if currTile then
            mwTiles[currTile]:setText('')
            table.remove(mwTiles, currTile)
        else
            table.insert(mwTiles, tile)
            mwTiles[#mwTiles]:setText("Ativo", "green")
        end
    end
end)

addSwitch('MagicWall', 'Magic Wall Rune', function(widget)
    widget:setOn(not widget:isOn())
    if not widget:isOn() then
        for i = 1, #mwTiles do
            mwTiles[1]:setText('')
            table.remove(mwTiles, 1)
        end
    end
    autoMw = widget:isOn()
end)

macro(1, function()
    if autoMw then
        for _, tile in pairs(mwTiles) do
			if tile:getTimer() <= 100 then
				useWith(3180, tile:getTopUseThing())
				return
			end
        end
    end
end)

UI.Separator()

local wwTiles = {}
local autoWw = false

onKeyPress(function(keys)
    if keys == "Home" and autoWw then
        local tile = getTileUnderCursor()
        local currTile = table.find(wwTiles, tile)
        if currTile then
           wwTiles[currTile]:setText('')
            table.remove(wwTiles, currTile)
        else
            table.insert(wwTiles, tile)
            wwTiles[#wwTiles]:setText("Ativo", "blue")
        end
    end
end)

addSwitch('WildWall', 'Wild Growth Rune', function(widget)
    widget:setOn(not widget:isOn())
    if not widget:isOn() then
        for i = 1, #wwTiles do
            wwTiles[1]:setText('')
            table.remove(wwTiles, 1)
        end
    end
    autoWw = widget:isOn()
end)

macro(1, function()
    if autoWw then
        for _, tile in pairs(wwTiles) do
			if tile:getTimer() <= 100 then
				useWith(3156, tile:getTopUseThing())
				return
			end
        end
    end
end)

UI.Separator()

UI.TextEdit(storage.follow , function(widget, newText) storage.follow = newText end)
local toFollow = storage.follow
local toFollowPos = {}

macro(333, "Follow", function()
    toFollow = storage.follow
    if toFollow == player:getName() then return end
    local target = getCreatureByName(toFollow)

    if target then
        local targetpos = target:getPosition()
        toFollowPos[targetpos.z] = targetpos
    end

    if player:isWalking() then return end
    local pos = toFollowPos[posz()]
    if not pos then return end
        if autoWalk(pos, 20, {ignoreNonPathable = true, precision = 1}) then
            if not g_game.isFollowing(target) and not g_game.isAttacking() then
                g_game.follow(target)
            end
            delay(333)
        end
end)

onCreaturePositionChange(function(creature, oldPos, newPos)
    if creature:getName() == toFollow and newPos ~= nil then
        toFollowPos[newPos.z] = newPos
    end
end)

UI.Separator()



macro(1, "Destroy Field", function()
local tiles = g_map.getTile(pos())
local ids = tiles:getTopThing():getId()

    for i, item in pairs({2123, 2126, 2121, 2125, 2124}) do
        if item == ids then
            g_game.useInventoryItemWith(3148, player, 1)
        end
    end
end)


macro(1, "Anti-Push", function()
local tile = g_map.getTile(pos())
local id = tile:getTopThing():getId()
    if tile and tile:getThingCount() < 6 then
        local thing = tile:getTopThing()
        if thing and not thing:isNotMoveable() then
            for i, item in pairs({3035, 3031}) do
                if item ~= id then
                    local drop = findItem(item)
                    if drop then
                        g_game.move(drop, pos(), math.random(1, 2))
                    else
                        if (not findItem(3031)) then
                            g_game.use(findItem(3035))
                            delay(500)
                        end
                        if (not findItem(3035)) then
                            g_game.use(findItem(3043))
                            delay(500)
                        end
                        if (not findItem(3043)) then
                            g_game.use(findItem(9058))
                            delay(500)
                        end
                    end
                end
            end
        end
    end
end)

macro(1 , "Push Items", function()
    local item = nil
    for _, tile in pairs(g_map.getTiles(posz())) do
        if distanceFromPlayer(tile:getPosition()) == 1 and #tile:getItems() ~= 0 and not tile:getTopUseThing():isNotMoveable() then
            item = tile:getTopUseThing()
            if item:isPickupable() then
                g_game.move(item, {x=65535, y=3, z=0}, item:getCount())
            end
            return
        end
    end
end)
 
UI.Separator()